part of '../../style_base.dart';

///
abstract class CryptoService extends _BaseService {
  ///
  void encrypt();

  ///
  Future<String> socketDataEncryptFull(
      String plain, Uint8List clientNonce, Uint8List serverNonce) async {
    return encrypt2ndStage(
        await encrypt1stStage(plain, clientNonce), serverNonce);
  }

  ///
  Future<String> socketDataDecryptFull(
      String cipher, Uint8List clientNonce, Uint8List serverNonce) async {
    return decrypt1stStage(
        await decrypt2ndStage(cipher, serverNonce), clientNonce);
  }

  ///
  Future<String> encrypt1stStage(String plain, Uint8List clientNonce);

  ///
  Future<String> encrypt2ndStage(String plain, Uint8List serverNonce) =>
      encrypt1stStage(plain, serverNonce);

  ///
  Future<String> decrypt1stStage(String cipher, Uint8List clientNonce);

  ///
  Future<String> decrypt2ndStage(String cipher, Uint8List serverNonce) =>
      decrypt1stStage(cipher, serverNonce);

  ///
  Future<List<int>> calculateSha256MacAlternative(List<int> plain);

  ///
  Future<List<int>> calculateSha256Mac(List<int> plain);

  ///
  Future<List<int>> calculateSha1Mac(List<int> plain);
}

///
class DefaultCryptoHandler extends CryptoService {
  @override
  void encrypt() {
    // TODO: implement encrypt
  }

  @override
  Future<bool> init([bool inInterface = true]) async {
    return true;
  }

  @override
  Future<List<int>> calculateSha1Mac(List<int> plain) {
    // TODO: implement calculateSha1Mac
    throw UnimplementedError();
  }

  @override
  Future<List<int>> calculateSha256Mac(List<int> plain) {
    // TODO: implement calculateSha256Mac
    throw UnimplementedError();
  }

  @override
  Future<List<int>> calculateSha256MacAlternative(List<int> plain) {
    // TODO: implement calculateSha256MacAlternative
    throw UnimplementedError();
  }

  @override
  Future<String> decrypt1stStage(String cipher, Uint8List clientNonce) {
    // TODO: implement decrypt1stStage
    throw UnimplementedError();
  }

  @override
  Future<String> encrypt1stStage(String plain, Uint8List clientNonce) {
    // TODO: implement encrypt1stStage
    throw UnimplementedError();
  }
}
